Listing 1
POPMENU Function

FUNCTION popmenu
PARAMETERS p_rr, p_cc, bx_mess, opt_1, opt_2, ;
           opt_3, opt_4, opt_5
PRIVATE p_rr, p_cc, bx_mess, num_opts, num_lines
PRIVATE opt_1, opt_2, opt_3, opt_4, opt_5, num, no
PRIVATE i, max_line, m_bar, cur_width, rvalue

num_opts = 5

IF len(trim(opt_5)) = 0
  num_opts = 4

  IF len(trim(opt_4)) = 0
    num_opts = 3

    IF len(trim(opt_3)) = 0
      num_opts = 2
    ENDIF

  ENDIF

ENDIF

DEFINE POPUP popmen FROM 00,00

***  paint the message that is to appear at 
***  the top of the menu.  The logic used to
***  paint the menu header speeds up the program.

IF len(bx_mess) > 0      && if message not null

  IF len(bx_mess) <= 30  && if mess is one line

    DEFINE BAR 1 OF popmen PROMPT ' '+bx_mess SKIP
    i = 2
    num_lines = 2

  ELSE                    && if message 2+ lines

    num_lines = mlcount(bx_mess,30)
    i = 1

    DO WHILE i <= num_lines
      DEFINE BAR i OF popmen PROMPT ' ' + ;
                 memoline(bx_mess,30,i) + ' ' SKIP
      i = i + 1
    ENDDO

    num_lines = num_lines + 1

  ENDIF

  DEFINE BAR i OF popmen PROMPT ;
               replicate(chr(196),32)  SKIP
  i = i + 1

ELSE                &&  we have no header message

***  force the width of the menu to 30 spaces 
  
  opt_1 = opt_1 + space(25-len(opt_1))
  num_lines = 0     &&  modify for return value
  i = 1

ENDIF

***  define the first two bars, they are there in all menus

DEFINE BAR i of popmen PROMPT '     ' + opt_1
DEFINE BAR i + 1 of popmen PROMPT '     ' + opt_2
i = i + 2

DO CASE

  CASE num_opts = 3
    DEFINE BAR i of popmen PROMPT '     ' + opt_3
    i = i + 1

  CASE num_opts = 4
    DEFINE BAR i of popmen PROMPT '     ' + opt_3
    DEFINE BAR i +1 of popmen PROMPT '     ' + ;
                              opt_4
    i = i + 2

  CASE num_opts = 5
    DEFINE BAR i of popmen PROMPT '     ' + opt_3
    DEFINE BAR i + 1 of popmen PROMPT '     ' + ;
                               opt_4
    DEFINE BAR i + 2 of popmen PROMPT '     ' + ;
                               opt_5
    i = i + 3

ENDCASE

***  when a selection is made get rid of the menu

ON SELECTION POPUP popmen DEACTIVATE POPUP

***  set up the underlying window so that the 
***  menu is independant of any underlying 
***  windows.  Make sure that the whole thing 
***  fits on the screen!

p_rr = iif(p_rr+i<24,p_rr,24-i)
p_cc = iif(p_cc<47,p_cc,46)

DEFINE WINDOW popmenu FROM p_rr,p_cc ;
                      TO p_rr+i,p_cc+33 NONE
ACTIVATE WINDOW popmenu

m_bar = 0

DO WHILE m_bar = 0    &&  no escape allowed
  ACTIVATE POPUP popmen
  m_bar = bar()
ENDDO

rvalue = bar() - num_lines
RELEASE POPUP popmen      &&  get rid of popup
RELEASE WINDOW popmenu    &&  get rid of window

RETURN(rvalue)

